//
//  NewsfeedPresenter.swift
//  VKExt
//
//  Created programmist_NA on 25.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class NewsfeedPresenter: NewsfeedPresenterProtocol {
    
    weak private var view: NewsfeedViewProtocol?
    var interactor: NewsfeedInteractorProtocol?
    private let router: NewsfeedWireframeProtocol
    let selfService = SelfService.instance
    
    init(interface: NewsfeedViewProtocol, interactor: NewsfeedInteractorProtocol?, router: NewsfeedWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }
    
    func start(request: Newsfeed.Model.Request.RequestType) {
        guard let interactor = self.interactor else { return }
        interactor.start(request: request)
    }
    
    func onLikePost(request: Newsfeed.Model.Request.RequestType) {
        guard let interactor = self.interactor else { return }
        interactor.makeRequest(request: request)
    }
    
    func presentData(response: Newsfeed.Model.Response.ResponseType) {
        switch response {
        case .presentStories(let response, _):
            let cells = response.items?.compactMap { $0 }.compactMap { $0.stories }.map { item in
                storiesCellViewModel(from: item.first!, profiles: response.profiles ?? [], groups: response.groups ?? [])
            }
            
            
            let storiesViewModel = StoriesViewModel.init(cells: cells ?? [], footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayStories(storiesViewModel: storiesViewModel))
            }
        case .presentNewsfeed(let feed, let revealdedPostIds):
            let cells = feed.items.map { (feedItem) in
                cellViewModel(from: feedItem, profiles: feed.profiles, groups: feed.groups, revealdedPostIds: revealdedPostIds)
            }
            
            let footerTitle = String.localizedStringWithFormat(NSLocalizedString("newsfeed cells count", comment: ""), cells.count)
            let feedViewModel = FeedViewModel.init(cells: cells, footerTitle: footerTitle)
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayNewsfeed(feedViewModel: feedViewModel))
            }
        case .presentFooterLoader:
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterLoader)
            }
        case .presentFooterError(message: let messageError):
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterError(message: messageError))
            }
        default:
            break
        }
    }
    
    func onReloadData() {
        DispatchQueue.main.async {
            self.view?.reloadData()
        }
    }
    
    private func storiesCellViewModel(from storie: ItemStory, profiles: [ProfileHistory], groups: [GroupHistory]) -> StoriesViewModel.Cell {
        let profile = self.profile(for: storie.ownerId ?? 0, profilesHistory: profiles, groupsHistory: groups)
        
        let date = Date(timeIntervalSince1970: Double(storie.date ?? 0))
        let dateTitle = selfService.dateFormatter.string(from: date)
        
        let expiresAt = Date(timeIntervalSince1970: Double(storie.expiresAt ?? 0))
        let expiresAtTitle = selfService.dateFormatter.string(from: expiresAt)
        
        return StoriesViewModel.Cell.init(photoUrl: profile.photo, name: profile.name, id: (storie.id ?? 0).stringValue, ownerId: (storie.ownerId ?? 0).stringValue, date: dateTitle, expiresAt: expiresAtTitle, seen: 0)
    }
    
    private func cellViewModel(from feedItem: FeedItem, profiles: [Profile], groups: [Group], revealdedPostIds: [Int]) -> FeedViewModel.Cell {
        let profile = self.profile(for: feedItem.sourceId, profiles: profiles, groups: groups)
        let photoAttachments = self.photoAttachments(feedItem: feedItem)
        
        let date = Date(timeIntervalSince1970: feedItem.date)
        let dateTitle = selfService.postDate(with: date).string(from: date)
        
        let isFullSized = revealdedPostIds.contains { (postId) -> Bool in
            return postId == feedItem.postId
        }
        
        let sizes = selfService.cellLayoutCalculator.sizes(postText: feedItem.text, photoAttachments: photoAttachments, isFullSizedPost: isFullSized, isRepost: false)
        
        let postText = feedItem.text?.replacingOccurrences(of: "<br>", with: "\n")
        
        if let repost = feedItem.copyHistory?.first {
            let profileRepost = self.profile(for: repost.ownerId, profiles: profiles, groups: groups)
            let photoRepostAttachments = self.photoAttachments(repostItem: repost)
            let repostText = repost.text?.replacingOccurrences(of: "<br>", with: "\n")
            let date = Date(timeIntervalSince1970: repost.date)
            let dateTitle = selfService.postDate(with: date).string(from: date)
            
            let feedRepostCellViewModel = FeedViewModel.FeedRepost.init(id: repost.id, ownerId: repost.ownerId, type: repost.postType, iconUrlString: profileRepost.photo, name: profileRepost.name, date: dateTitle, text: repostText, photoAttachements: photoRepostAttachments)
            
            let isFullSized = revealdedPostIds.contains { (postId) -> Bool in
                return postId == repost.id
            }
            
            let sizes = selfService.cellLayoutCalculator.sizes(postText: repost.text, photoAttachments: photoRepostAttachments, isFullSizedPost: isFullSized, isRepost: true)
            
            return FeedViewModel.Cell.init(postId: repost.id,
                                           sourceId: repost.ownerId,
                                           type: repost.postType,
                                           iconUrlString: profile.photo,
                                           name: profile.name,
                                           date: dateTitle,
                                           text: postText,
                                           likes: formattedCounter(feedItem.likes?.count),
                                           userLikes: feedItem.likes?.userLikes,
                                           comments: formattedCounter(feedItem.comments?.count),
                                           shares: formattedCounter(feedItem.reposts?.count),
                                           views: formattedCounter(feedItem.views?.count),
                                           photoAttachements: photoAttachments,
                                           repost: [feedRepostCellViewModel],
                                           sizes: sizes)
        } else {
            return FeedViewModel.Cell.init(postId: feedItem.postId,
                                           sourceId: feedItem.sourceId,
                                           type: feedItem.type,
                                           iconUrlString: profile.photo,
                                           name: profile.name,
                                           date: dateTitle,
                                           text: postText,
                                           likes: formattedCounter(feedItem.likes?.count),
                                           userLikes: feedItem.likes?.userLikes,
                                           comments: formattedCounter(feedItem.comments?.count),
                                           shares: formattedCounter(feedItem.reposts?.count),
                                           views: formattedCounter(feedItem.views?.count),
                                           photoAttachements: photoAttachments,
                                           sizes: sizes)
        }
    }
    
    private func formattedCounter(_ counter: Int?) -> String? {
        guard let counter = counter, counter > 0 else { return nil }
        var counterString = String(counter)
        if 4...6 ~= counterString.count {
            counterString = String(counterString.dropLast(3)) + "K"
        } else if counterString.count > 6 {
            counterString = String(counterString.dropLast(6)) + "M"
        }
        return counterString
    }
    
    private func profile(for sourseId: Int, profiles: [Profile] = [], profilesHistory: [ProfileHistory] = [], groups: [Group] = [], groupsHistory: [GroupHistory] = []) -> ProfileRepresenatable {
        
        let profilesOrGroups: [ProfileRepresenatable]
        if !profiles.isEmpty && !groups.isEmpty {
            profilesOrGroups = sourseId >= 0 ? profiles : groups
        } else {
            profilesOrGroups = sourseId >= 0 ? profilesHistory : groupsHistory
        }
        let normalSourseId = sourseId >= 0 ? sourseId : -sourseId
        let profileRepresenatable = profilesOrGroups.first { (myProfileRepresenatable) -> Bool in
            myProfileRepresenatable.id == normalSourseId
        }
        return profileRepresenatable!
    }
    
    private func photoAttachments(feedItem: FeedItem) -> [FeedViewModel.FeedCellPhotoAttachment] {
        guard let attachments = feedItem.attachments else { return [] }
        
        return attachments.compactMap({ (attachment) -> FeedViewModel.FeedCellPhotoAttachment? in
            if let photo = attachment.photo {
                return FeedViewModel.FeedCellPhotoAttachment.init(photoUrlString: photo.srcBIG,
                                                                  photoMaxUrl: photo.srcMax,
                                                                  width: photo.width,
                                                                  height: photo.height)
            } else if let doc = attachment.doc {
                return FeedViewModel.FeedCellPhotoAttachment.init(gifUrl: doc.url,
                                                                  photoUrlString: doc.preview?.photo?.srcBIG ?? "",
                                                                  photoMaxUrl: doc.preview?.photo?.srcMax ?? "",
                                                                  width: doc.preview?.photo?.width ?? 0,
                                                                  height: doc.preview?.photo?.height ?? 0)
            } else {
                return nil
            }
        })
    }
    
    private func photoAttachments(repostItem: RepostItem) -> [FeedViewModel.FeedCellPhotoAttachment] {
        guard let attachments = repostItem.attachments else { return [] }
        
        return attachments.compactMap({ (attachment) -> FeedViewModel.FeedCellPhotoAttachment? in
            if let photo = attachment.photo {
                return FeedViewModel.FeedCellPhotoAttachment.init(photoUrlString: photo.srcBIG,
                                                                  photoMaxUrl: photo.srcMax,
                                                                  width: photo.width,
                                                                  height: photo.height)
            } else if let doc = attachment.doc {
                return FeedViewModel.FeedCellPhotoAttachment.init(gifUrl: doc.url,
                                                                  photoUrlString: doc.preview?.photo?.srcBIG ?? "",
                                                                  photoMaxUrl: doc.preview?.photo?.srcMax ?? "",
                                                                  width: doc.preview?.photo?.width ?? 0,
                                                                  height: doc.preview?.photo?.height ?? 0)
            } else {
                return nil
            }
        })
    }
}
